<?php

class Helper {
	
	public function check_navigation_type(){

		$type = 'no';
		
		if (file_exists(LANG_path.PATH_onepager)) {
		
			include(LANG_path.PATH_onepager);
			if($active == 'yes'){$type = 'onepager';}
			
		//Check if the URL Optimizer Plugin is available
		}elseif (file_exists(LANG_path.PATH_url_optimizer) AND (file_exists(LANG_path.'.htaccess') OR file_exists(LANG_path.'web.config'))) {
		
			include(LANG_path.PATH_url_optimizer);
			if($active == 'yes'){$type = 'urloptimizer';}
		}
		
		define("PATH_navigation_type", $type);
	}
	
	public function clean_code($data,$mode){

		if($mode == 'save'){
			$data = $this->get_content_with_changed_paths($data);
		}
		
		if($mode == 'get'){
			$data = $this->get_changed_paths($data);
		}
		
		return $data;
	}
	
	private function get_content_with_changed_paths($datensatz){
		
			//http://localhost/DoITclever/08-Programmierung/V1-5-7/1119/Homepage/uploads/thumb-1920-876898.jpg
			$current_url =  (isset($_SERVER['HTTPS']) ? "https" : "http") . "://".$_SERVER['HTTP_HOST']."".dirname($_SERVER['PHP_SELF']);
			//Resultat: http://localhost/DoITclever/08-Programmierung/V1-5-7/1287/Homepage/plugins/Footer
			$url = substr($current_url, 0, strpos($current_url, 'Homepage'));
			//Resultat: http://localhost/DoITclever/08-Programmierung/V1-5-7/1287/
			$datensatz = str_replace($url,'',$datensatz);
			//Resultat: Homepage/uploads/favicon.jpg
			
			//Zur Sicherheit wird zum Schluss die Nummer nochmals entfernt, falls doch noch vorhanden (kommt vor)
			$datensatz = str_replace('../../../Homepage/', 'Homepage/', $datensatz);
			//Resultat: Homepage/uploads/favicon.jpg

			return $datensatz; //Homepage/uploads/favicon.jpg

	}
	
	private function get_changed_paths($data){
		
		//Bestehende zurückskallieren
		$data = str_replace('../../../Homepage/', 'Homepage/', $data);
		
		//Dann alle gemeinsam wieder anpassen
		$data = str_replace('Homepage/', '../../../Homepage/', $data);
		
		return $data;
		
	}
	
	public function clean_name($data){
		
		$cleanname = strtolower($data);
		$cleanname = str_replace(' ','',$cleanname);
		$cleanname = str_replace('&','',$cleanname);
		$cleanname = str_replace('?','',$cleanname);
		$cleanname = str_replace('ä','ae',$cleanname);
		$cleanname = str_replace('ö','oe',$cleanname);
		$cleanname = str_replace('ü','ue',$cleanname);
		$cleanname = str_replace('Ä','Ae',$cleanname);
		$cleanname = str_replace('Ö','Oe',$cleanname);
		$cleanname = str_replace('Ü','Ue',$cleanname);
		$cleanname = str_replace('(','_',$cleanname);
		$cleanname = str_replace(')','_',$cleanname);
		$cleanname = str_replace(',','_',$cleanname);
		$cleanname = str_replace('.','_',$cleanname);
		
		return $cleanname;
	}
	
	public function decode_html($value){
		return html_entity_decode(htmlspecialchars_decode($value));
	}
	
	public function encode_html($value){
		return htmlentities(htmlspecialchars($value));
	}
	
}

?>