<?php

include_once('ClsHelper.php');

class Navigation {
	
	function __construct() {
		// Prepares all navi extra classes from the structure.json as an array to reduce the loading time
		$this->add_foundation_class();
	}
	
	function create($navigation_id){

		//Create the navigation (by_name or by_id)
		$result = $this->create_navigation($navigation_id);
		
		return $result;
	}
	
	private function create_navigation($navigation_id){
		
		$help = new Helper();
		
		//If there is a GET parameter named &notrack=1 so it will be added to all urls
		if(isset($_GET['notrack'])){$notrack = '&notrack='.$_GET['notrack'];}else{$notrack = '';}
		
		$class1 = 'navi'.$navigation_id.'_ul';
		$class2 = 'navi'.$navigation_id.'_ul_li';
		$class3 = 'navi'.$navigation_id.'_ul_li_a';
			
		$html = '';
		$list = '';

		$database = new PDO('sqlite:'.LANG_path.PATH_sqlite_path.'');
		$result = $database->query("
		SELECT a.id, a.parent_id, a.meta_title, a.fk_language, b.lang, a.meta_pagetitle FROM sites as a
		INNER JOIN language as b ON a.fk_language = b.id 
		WHERE a.navigation_id = ".intval($navigation_id)." AND b.lang = '".LANG_current_language."' AND a.parent_id = 0 AND a.active = 1 AND a.visible = 1 ORDER BY a.sort asc;");
		
		if(is_null ($result) == false){ //Wenn das Array nicht NULL ist
			if($result){// Prüft, ob es das Objekt gibt
				while ($row = $result->fetch()){

					//Clean Meta Title for URL Optimization
					if (PATH_navigation_type == "onepager"){
						$href = '#'.$help->clean_name($row['meta_title']);
					}elseif(substr($row['meta_title'], 0, 1) === '#') {
						$href = $row['meta_title'];
					}elseif(PATH_navigation_type == 'urloptimizer'){
						$href = $row['meta_title'];
					}else{
						$href = 'index.php?page='.$row['id'].''.$notrack;
					}
					
					//Ausgewählte Seite wird gefärbt
					if(isset($_GET['page']) AND $row['id'] == $_GET['page']){$navactive = 'active';}else{$navactive = '';}
						
					$list .= '<li class="'.$this->foundation_divs[$class2].'  '.$navactive.'">
									<a href="'.$href.'" id="ulink'.$row['id'].'" class="'.$this->foundation_divs[$class3].'">'. $row['meta_pagetitle'].'</a>
									'.$this->create_sub_navigation($navigation_id,$row['id']).'
								</li>';
				}
			}
		}
		
		$html = '<ul class="'.$this->foundation_divs[$class1].'">'.$list.'</ul>';

		$database = null; // Schliesst DB Verbindung
		
		return $html;

	}
	
	private function create_sub_navigation($navigation_id,$id){
		
		$help = new Helper();
		
		//If there is a GET parameter named &notrack=1 so it will be added to all urls
		if(isset($_GET['notrack'])){$notrack = '&notrack='.$_GET['notrack'];}else{$notrack = '';}
		
		$class1 = 'navi'.$navigation_id.'_ul_li_ul';
		$class2 = 'navi'.$navigation_id.'_ul_li_ul_li';
		$class3 = 'navi'.$navigation_id.'_ul_li_ul_li_a';
			
		$html = '';
		$list = '';

		$database = new PDO('sqlite:'.LANG_path.PATH_sqlite_path.'');
		$result = $database->query("
		SELECT a.id, a.parent_id, a.meta_title, a.fk_language, b.lang, a.meta_pagetitle FROM sites as a
		INNER JOIN language as b ON a.fk_language = b.id 
		WHERE a.navigation_id = ".intval($navigation_id)." AND b.lang = '".LANG_current_language."' AND a.parent_id = ".$id." AND a.active = 1 AND a.visible = 1 ORDER BY a.sort asc;");
		
		if(is_null ($result) == false){ //Wenn das Array nicht NULL ist
			if($result){// Prüft, ob es das Objekt gibt
				while ($row = $result->fetch()){

					//Clean Meta Title for URL Optimization
					//Clean Meta Title for URL Optimization
					if (PATH_navigation_type == "onepager"){
						$href = '#'.$help->clean_name($row['meta_title']);
					}elseif(substr($row['meta_title'], 0, 1) === '#') {
						$href = $row['meta_title'];
					}elseif(PATH_navigation_type == 'urloptimizer'){
						$href = $row['meta_title'];
					}else{
						$href = 'index.php?page='.$row['id'].''.$notrack;
					}
					
					//Ausgewählte Seite wird gefärbt
					if(isset($_GET['page']) AND $row['id'] == $_GET['page']){$navactive = 'active';}else{$navactive = '';}
					
					$list .= '<li class="'.$this->foundation_divs[$class2].' '.$navactive.'">
									<a href="'.$href.'" id="ulink'.$row['id'].'" class="'.$this->foundation_divs[$class3].'">'. $row['meta_pagetitle'].'</a>
								</li>';
				}
			}
		}
		
		if($list != ''){
			$html = '<ul class="'.$this->foundation_divs[$class1].'">'.$list.'</ul>';
		}

		$database = null; // Schliesst DB Verbindung
		
		return $html;
	}
	
	private function add_foundation_class(){
		
		$this->foundation_divs = array();
		
		if(file_exists(LANG_path.PATH_website_foundation_extra)){
			$this->foundation_divs = json_decode(file_get_contents(LANG_path.PATH_website_foundation_extra),TRUE); //Array als Konstante aus dem Foundation.php
		}

	}

}
?>