<?php

require_once( 'ClsDivs.php' );

class Plugins {
	
	public function check_plugin_include($site_id,$div_id,$mode = ''){
	
		$plugin_array = $this->get_plugins($site_id);
		$divs = new Divs();
			
		if(count($plugin_array) > 0){
				
			//So that several plugins can be loaded on a page, a loop is needed
			for ($i = 0; $i < count($plugin_array['plugin_name']); $i++){
				
				if($plugin_array['div'][$i] == $div_id){

					if(file_exists(LANG_path.PATH_plugin_path.$plugin_array['plugin_name'][$i].'.php')){

						if($mode == 'edit'){
							if(file_exists(LANG_path.PATH_plugin_path.$plugin_array['plugin_name'][$i].'/view.php') == true AND $divs->check_div_is_visible($div_id) == true){
								//include(LANG_path.PATH_plugin_path.$plugin_array['plugin_name'][$i].'/view.php');
	
								echo '<iframe class="short_view" src="'.LANG_path.PATH_plugin_path.$plugin_array['plugin_name'][$i].'/view.php?shortcut=yes&page='.@$content_array['id'].'"></iframe>';
							}else{
								include(LANG_path.PATH_plugin_path.$plugin_array['plugin_name'][$i].'.php');
							}
						}else{
							include(LANG_path.PATH_plugin_path.$plugin_array['plugin_name'][$i].'.php');
						}
					}
				}
			}
		}
	
	}
	
	private function get_plugins($site_id){
	
		$database = new PDO('sqlite:'.LANG_path.PATH_sqlite_path.'');
		$result = $database->query("
		SELECT * FROM plugins as a 
		LEFT JOIN sites as b ON a.fk_sites = b.id
		LEFT JOIN language as c ON a.fk_language = c.id
		WHERE (b.id = ".intval($site_id)." OR a.active_all_sites = 1) 
		AND c.lang = '".LANG_current_language."';");
		
		$datensatz = array();
  
		while ($zeile = $result->fetch()) 
			{
                $datensatz['plugin_name'][] = $zeile['plugin_name'];
				$datensatz['div'][]         = $zeile['fk_divs'];
            }
		
		$database = null; // Schliesst DB Verbindung

		//Return an array
		return $datensatz;
	}
	
	public function check_style_include($site_id){
	
		$plugin_array = $this->get_plugins($site_id);
		
		if(count($plugin_array) > 0){
			foreach ($plugin_array['plugin_name'] as $plugin_name) {
				
				$filename = LANG_path.PATH_plugin_path.$plugin_name.PATH_plugin_style_path;
				if (file_exists($filename)) {
					echo '<link rel="stylesheet" href="'.$filename.'" type="text/css">';
				}
			}

		}
	}
	
	public function check_meta_include($site_id,$part){
	
		$plugin_array = $this->get_plugins($site_id);
		
		if(count($plugin_array) > 0){
			foreach ($plugin_array['plugin_name'] as $plugin_name) {
				
				if($part == '1'){
					$filename = LANG_path.PATH_plugin_path.$plugin_name.PATH_plugin_meta_path;
					if (file_exists($filename)) {
						include($filename);
					}
				}else if($part == '2'){
					$filename = LANG_path.PATH_plugin_path.$plugin_name.PATH_plugin_meta_path_second;
					if (file_exists($filename)) {
						include($filename);
					}
				}
			}

		}
	}
	
	public function check_includes($site_id){
	
		$plugin_array = $this->get_plugins($site_id);
		
		if(count($plugin_array) > 0){
			foreach ($plugin_array['plugin_name'] as $plugin_name) {
				
				$filename = LANG_path.PATH_plugin_path.$plugin_name.PATH_plugin_include_path;
				if (file_exists($filename)) {
					include($filename);
				}
			}
		}
	}
	
	/*====================================================== ACTIVE DEVELOPER MODE ===============================================================*/
	public function direct_plugin_include(){
		
		foreach (glob(LANG_path.PATH_plugin_path."*.php") as $filename){
			include($filename);
		}
		
	}
	
	public function direct_style_includes(){
		
		foreach (glob(LANG_path.PATH_plugin_path."*.php") as $filename){
			$filename = str_replace('.php','',$filename);
			$filename = str_replace(LANG_path.PATH_plugin_path,'',$filename);
			$filename = LANG_path.PATH_plugin_path.$filename.PATH_plugin_style_path;
			if (file_exists($filename)) {
				echo '<link rel="stylesheet" href="'.$filename.'" type="text/css">';
			}
		}
		
	}
	
	public function direct_meta_includes(){
		
		foreach (glob(LANG_path.PATH_plugin_path."*.php") as $filename){
			$filename = str_replace('.php','',$filename);
			$filename = str_replace(LANG_path.PATH_plugin_path,'',$filename);
			$filename = LANG_path.PATH_plugin_path.$filename.PATH_plugin_meta_path;
			if (file_exists($filename)) {
				include($filename);
			}
		}
		
	}
	
	public function direct_paths_includes(){
		
		foreach (glob(LANG_path.PATH_plugin_path."*.php") as $filename){
			$filename = str_replace('.php','',$filename);
			$filename = str_replace(LANG_path.PATH_plugin_path,'',$filename);
			$filename = LANG_path.PATH_plugin_path.$filename.PATH_plugin_include_path;
			if (file_exists($filename)) {
				include($filename);
			}
		}
		
	}
	
}
?>