<?php

include_once('ClsGroups.php');

class Blog {
	
	public function check_functions(){
		
		if(isset($_POST['save'])){
			return $this->save_code($_POST['code']);
		}
		
		if(isset($_POST['save_entry'])){	

			//Wenn das Plugin "Elfinder" existiert, müssen die Bildpfade geändert werden
			if(file_exists('../../php/Classes/ClsHelper.php')){
				include_once('../../php/Classes/ClsHelper.php');
				$helper = New Helper();
				$message = $helper->clean_code($_POST['message'],'save');
			}else{
				$message = $_POST['message'];
			}
			
			if(isset($_POST['id'])){$id = $_POST['id'];}else{$id = '';}
			if(isset($_POST['selected_page']) AND $_POST['selected_page'] != ''){$pageid = $_POST['selected_page'];}else{$pageid = 0;}
			
			return $this->save_entry($id,$message,$_POST['title'],$_POST['subtitle'],$_POST['autor'],$_POST['description'],$_POST['url'],$_POST['video'],$_POST['published'],$_POST['ended'],$_FILES['picture'],$pageid);
		}
		
		if(isset($_POST['delete_entry'])){
			return $this->delete_entry($_POST['id']);
		}
		
		if(isset($_POST['id'])){
			
			$message = '';
			
			if(isset($_POST['set_home']) AND $_POST['set_home'] != ''){$checkbox = 'checked';}else{$checkbox = '';}
			$message = $this->set_status('home',$_POST['id'],$checkbox);

			if(isset($_POST['set_visible']) AND $_POST['set_visible'] != ''){$checkbox = 'checked';}else{$checkbox = '';}
			$message = $this->set_status('visible',$_POST['id'],$checkbox);
			
			if(isset($_POST['set_rss']) AND $_POST['set_rss'] != ''){$checkbox = 'checked';}else{$checkbox = '';}
			$message = $this->set_status('rss',$_POST['id'],$checkbox);
			
			return $message;
		}
		
	}
	
	public function create_dir($dir){
		
		if (!file_exists($dir)) {
			@mkdir($dir, 0777, true);
		}
	}
	
	public function get_replaces(){
		
		$replaces = unserialize(KONST_original_blog_array_replaces); //Array als Konstante aus dem Sprachfile
		
		$html = '';
		foreach($replaces as $value){
			$html .= '[['.$value.']] , ';
		}
		
		$html = substr($html, 0, -2); //Entfernt das letzte Komma
		
		return $html;
		
	}
	
	public function get_data($file){
		
		$data = array();
		$data = json_decode(file_get_contents($file));
		
		$html = '';
		foreach($data as $code => $value){
			if ($code == LANG_current_language) { //Prüft die Sprache des Datensatzes
				$html .= $value;
			}
		}
		
		return $html;
	}
	
	private function save_code($code){
		
		$data = array();
		$existingdata = json_decode(file_get_contents('data.json'));
		
		//Ersetzt die gewünschte Zeile im JSON (nur nötig, wenn der Code mehrsprachig gespeichert werden soll)
		foreach($existingdata as $key => $value){
			if ($key == LANG_current_language) { //Prüft die Sprache des Datensatzes
				$data[$key] = $code;
			}else{
				$data[$key] = $value;
			}
		}
		
		if(!array_key_exists(LANG_current_language,$data)){
			$data[LANG_current_language] = $code;
		}
		
		$file = 'data.json';
		$json_string = json_encode($data, JSON_PRETTY_PRINT);
		file_put_contents($file, $json_string);
		
		return LANG_plugin_original_blog_success;
		
	}
	
	public function get_blog($jsonfile, $id = '',$pageid = ''){
	
		$structurehtml = $this->get_data($jsonfile);
		
		$replaces = unserialize(KONST_original_blog_array_replaces); //Array als Konstante aus dem Sprachfile
		
		$string = '';
		$html = '';
		$single= '';
		$sites= '';
		
		//Wenn eine Blog ID mitgegeben wird
		if($id != ''){
			$single = "AND a.id = :id";
		}
		
		//Wenn eine Page ID mitgegeben wird
		if($pageid != ''){
			$sites = 'OR a.fk_sites = '.$pageid.'';
		}

		$db = new PDO('sqlite:'.LANG_path.KONST_original_blog_db_path_website.'');
		if ($stmt = $db->prepare("SELECT a.id mainid,* FROM blog as a LEFT JOIN blog_pictures as b 
		ON a.id = b.fk_blog LEFT JOIN pictures as c 
		ON b.fk_pictures = c.id WHERE a.language = '".LANG_current_language."' AND a.visible = 1 AND a.active = 1 AND (ended >= date('now') OR ended = '') ".$single." AND (a.fk_sites IS NULL OR a.fk_sites = 0 ".$sites.") ORDER BY a.published desc;")) {

			if($id != ''){
				$stmt->bindParam(':id', $id);
			}
			
			$stmt->execute();
		
			if(is_null ($stmt) == false){ //Wenn das Array nicht NULL ist
				while ( $row = $stmt->fetch() ){

					$string = $structurehtml;
					
					foreach($replaces as $value){
						
						$param = '';
						
						//Spezialfälle
						if($value == 'picture'){
							$picture = $this->get_images($row['mainid']);
							$picture = LANG_path.KONST_original_blog_image_path_website.$picture;

							//Prüft, ob es das zurückgegebene Bild überhaupt gibt
							if(file_exists($picture)){$param = $picture;}else{$param = '';}
							
						}else if($value == 'message'){
							
							//Fügt den Bildern aus dem Editor den Sprachpfad an (../)
							if(LANG_path != ''){
								//PATH_upload_path  entspricht  'Homepage/uploads/'
								$param = str_replace('Homepage/uploads/', LANG_path.'Homepage/uploads/', $row[$value]); 
							}else{
								$param = $row[$value];
							}
						}else if($value == 'published' OR $value == 'ended'){
							
							$param = date("d.m.Y", strtotime($row[$value]) );
							
						}else{
							$param = $row[$value];
						}
						
						//Ersetzt die Parameter aus dem data.json mit den DB Code
						$string = str_replace('[['.$value.']]',$param,$string);
					}
					
					$html .= $string;
					
				}
			}
		
		}
		
		return $html;
	}
	
	private function get_images($id,$mode = ''){
		
		$html = "";
		
		if($mode == 'config'){
			$db = new PDO('sqlite:'.KONST_original_blog_db_path.'');
		}else{
			$db = new PDO('sqlite:'.LANG_path.KONST_original_blog_db_path_website.'');
		}
		
		if ($stmt = $db->prepare("SELECT * FROM blog_pictures as a 
		INNER JOIN pictures as b ON a.fk_pictures = b.id 
		WHERE a.fk_blog = ".$id.";")) {
			
			$stmt->execute();
		
			if(is_null ($stmt) == false){ //Wenn das Array nicht NULL ist
				while ( $row = $stmt->fetch() ){
					$html = $row['picture'];
				}
			}
		}
		
		return $html;

	}
	
	public function get_all_entries($pluginname) {

		$db = new PDO('sqlite:'.KONST_original_blog_db_path.'');
		
		//Nun wird geprüft, ob der Filter und damit auch die Page ID gesetzt wurde
		//Anhand dessen wird ein SQL Statement vorbereitet. Gibt es die Page ID, so wird danach abgefragt
		if(isset($_SESSION['page']) AND $_SESSION['page'] != '' AND $_SESSION['page'] != 0){
			$sql = "SELECT * FROM blog WHERE language = '".LANG_current_language."' AND active = 1 AND fk_sites = ".$_SESSION['page']." ORDER BY published desc;";
		}else{
			$sql = "SELECT * FROM blog WHERE language = '".LANG_current_language."' AND active = 1 AND (fk_sites IS NULL OR fk_sites = 0) ORDER BY published desc;";
		}
		
		$result = $db->query($sql);

		$html = "";
		if(is_null ($result) == false){ //Wenn das Array nicht NULL ist
			if($result){// Prüft, ob es das Objekt gibt
				while($row = $result->fetch())
				{
					if (count($row) > 0) {
						
						//Prüft, ob das Blog-News Plugin existiert
						if(file_exists('../'.$pluginname.'-News.php')){
							if($row['home'] == '1'){
								$home_active = 'checked';
							}else{
								$home_active = '';
							}
							
							$home = '<td><input name="set_home" type="checkbox" onchange="this.form.submit();" value="checked" '.$home_active.'></td>';
						}else{
							$home = '';
						}
						
						if($row['visible'] == '1'){
							$visible = 'checked';
						}else{
							$visible = '';
						}
						
						//Prüft, ob das Social Media Plugin existiert
						if(file_exists('../Social-Media.php')){
							if($row['rss'] == '1'){
								$rss_active = 'checked';
							}else{
								$rss_active = '';
							}
							
							$rss = '<td><input name="set_rss" type="checkbox" onchange="this.form.submit();" value="checked" '.$rss_active.'></td>';
						}else{
							$rss = '';
						}
						
						//Datumsformatierung
						if($row['published'] != ''){$published = date("d.m.Y", strtotime($row['published']));}else{$published = '';}
						if($row['ended'] != ''){$ended = date("d.m.Y", strtotime($row['ended']));}else{$ended = '';}
						
						
						$html .= '
						<form name="save" action="'.$_SERVER['PHP_SELF'].'" method="POST">
									<tr>
										<td>'.substr($row['title'], 0, 20).'</td>
										<td>'.htmlspecialchars (substr($row['message'], 0, 40)).' ...</span></td>
										<td>'.$published.'</td>
										<td>'.$ended.'</td>
										'.$home.'
										<td><input name="set_visible" type="checkbox" onchange="this.form.submit();" value="checked" '.$visible.'></td>
										'.$rss.'
										<!--<td><input class="fontawesome" type="submit" name="up" value="&#xf062;"></td>-->
										<!--<td><input class="fontawesome" type="submit" name="down" value="&#xf063;"></td>-->
										<td><a href="'.$_SERVER['PHP_SELF'].'?id='.$row['id'].'"><i aria-hidden="true" class="fa fa-pencil black"></i></a></td>
										<td><input class="fontawesome" type="submit" name="delete_entry" value="&#xf1f8;"></td>
									</tr>
							<input type="hidden" name="id" value="'.$row['id'].'">
						</form>';
					}
				}
			}
		}
		
		return $html;
	}
	
	public function get_entry_manager($pluginname){
		
		$groups = New Groups(); /*Fürs Dropdown*/
		
		$dynamic_divsize = '12';
		
		if(isset($_GET['id']) AND $_GET['id'] != ''){
			
			$id = $_GET['id'];
			
			$db = new PDO('sqlite:'.KONST_original_blog_db_path.'');
			if ($stmt = $db->prepare("SELECT * FROM blog WHERE id = :id;")) {
				
				$stmt->bindParam(':id', $id);
				$stmt->execute();
			
				if(is_null ($stmt) == false){ //Wenn das Array nicht NULL ist
					while ( $row = $stmt->fetch() ){
						$data[1] = $row['title'];
						$data[2] = $row['subtitle'];
						$data[3] = $row['autor'];
						$data[4] = $row['description'];
						$data[5] = $row['url'];
						$data[6] = $row['video'];
						$data[7] = $row['published'];
						$data[8] = $row['ended'];
						$data[9] = $row['id'];
						$data[10] = $row['message'];
						
						$picture = $this->get_images($row['id'],'config');
						$picture = KONST_original_blog_image_path.$picture;
							
						//Prüft, ob es das zurückgegebene Bild überhaupt gibt
						if((is_file($picture))&&(file_exists($picture))){
							$data[11] = '<div class="small-12 medium-2 large-2 columns"><img src="'.$picture.'"></div>';
							$dynamic_divsize = '10';
						}else{
							$data[11] = '';
						}
					}
				}
			}
		
		
			$show = '';
		}else{
			if(isset($_GET['new']) AND $_GET['new'] == 'yes'){
				$show = '';
				$data = array('','','','','','','',date("d.m.Y"),'','','','','','','','','');
			}else{
				$show = 'style="display: none;"';
				$data = array('','','','','','','',date("d.m.Y"),'','','','','','','','','');
			}
		}
		
		if($data[7] != ''){$published = date("d.m.Y", strtotime($data[7]));}else{$published = '';}
		if($data[8] != ''){$ended = date("d.m.Y", strtotime($data[8]));}else{$ended = '';}
		
		return '
		<div id="new_entry" '.$show.'>
			<form action="'.$_SERVER["PHP_SELF"].'" method="POST" enctype="multipart/form-data">
				<input class="button red" name="save_entry" type="submit" value="'.LANG_plugin_original_blog_do_save.'">
				<a class="button" href="'.$_SERVER["PHP_SELF"].'">'.LANG_plugin_original_blog_cancel.'</a>
				<div class="row">
					'.$groups->select_dropdown($pluginname,$data[9]).'
					<div class="small-'.$dynamic_divsize.' medium-'.$dynamic_divsize.' large-'.$dynamic_divsize.' columns">
						<table style="width:100%;">
							<tr style="background-color:#F5F5F5;">
								<td><strong>'.LANG_plugin_original_blog_title_title.'</strong></td>
								<td><strong>'.LANG_plugin_original_blog_title_subtitle.'</strong></td>
								<td><strong>'.LANG_plugin_original_blog_title_autor.'</strong></td>
								<td><strong>'.LANG_plugin_original_blog_title_description.'</strong></td>
							</tr>
							<tr>
								<td><input type="text" name="title" value="'.$data[1].'"></td>
								<td><input type="text" name="subtitle" value="'.$data[2].'"></td>
								<td><input type="text" name="autor" value="'.$data[3].'"></td>
								<td><input type="text" name="description" value="'.$data[4].'"></td>
							</tr>
							<tr style="background-color:#F5F5F5;">
								<td><strong>'.LANG_plugin_original_blog_title_url.'</strong></td>
								<td><strong>'.LANG_plugin_original_blog_title_video.'</strong></td>
								<td><strong>'.LANG_plugin_original_blog_title_published.'</strong></td>
								<td><strong>'.LANG_plugin_original_blog_title_ended.'</strong></td>
							</tr>
							<tr>
								<td><input type="text" name="url" value="'.$data[5].'"></td>
								<td><input type="text" name="video" value="'.$data[6].'"></td>
								<td><input type="text" class="ffdatepicker" name="published" value="'.$published.'"></td>
								<td><input type="text" class="ffdatepicker" name="ended" value="'.$ended.'"></td>
							</tr>
							<tr style="background-color:#F5F5F5;">
								<td><strong>'.LANG_plugin_original_blog_title_picture.'</strong></td>
							</tr>
							<tr>
								<td><input type="file" name="picture" value=""></td>
							</tr>
						</table>
					</div>
					'.$data[11].'
				</div>
				
				<div class="row">
					<div class="small-12 medium-12 large-12 small-centered columns">
					
						<h3>'.LANG_plugin_original_blog_title_message.'</h3>
						<textarea class="ckeditor" name="message" style="height:300px;" placeholder="'.LANG_plugin_original_blog_title_placeholder.'">'.$this->get_message_with_clean_paths($data[10]).'</textarea>
						<br/>
						
						<input type="hidden" name="id" value="'.$data[9].'">
					</div>
				</div>
			</form><hr/>
		</div>';
	}
	
	private function get_message_with_clean_paths($data){
		
		//Wenn das Plugin "Elfinder" existiert, müssen die Bildpfade geändert werden
		if(file_exists('../../php/Classes/ClsHelper.php')){
			include_once('../../php/Classes/ClsHelper.php');
			$helper = New Helper();
			$data = $helper->clean_code($data,'get');
		}
		
		return $data;
	}
	
	private function save_entry($id,$message,$title,$subtitle,$autor,$description,$url,$video,$published,$ended,$picture,$pageid){
		
		$this->save_picture($picture); /*Speichert das Bild auf dem Server*/
		$picture = $this->clean_name($picture["name"]); /*Entfernt Leerschläge, etc.*/
		
		//Datumsformatierung
		if($published != ''){$published = date("Y-m-d", strtotime($published));}else{$published = '';}
		if($ended != ''){$ended = date("Y-m-d", strtotime($ended));}else{$ended = '';}
		
		$db = new PDO('sqlite:'.KONST_original_blog_db_path.'');
		
		//Falls eine neue Bestellung angelegt wird
		if($id == ''){
			$stm = "INSERT INTO blog (`message`,`title`,`subtitle`,`autor`,`description`,`url`,`video`,`published`,`ended`,`language`,`visible`,`active`,`fk_sites`) VALUES
			(:message,'".$title."','".$subtitle."','".$autor."','".$description."','".$url."','".$video."','".$published."','".$ended."','".LANG_current_language."',0,1,".$pageid.");";

			if ($stmt = $db->prepare($stm)) {
				$stmt->bindParam(':message', $message);
				$stmt->execute();
				
				$this->save_picture_in_db($picture,$db->lastInsertId(),'insert');
				
				return LANG_plugin_original_blog_success;
			}	

		}else{
			$stm = "UPDATE blog SET 
			message = :message,
			title = '".$title."',
			subtitle = '".$subtitle."',
			autor = '".$autor."',
			description = '".$description."',
			url = '".$url."',
			video = '".$video."',
			published = '".$published."',
			ended = '".$ended."',
			fk_sites = ".$pageid."
			WHERE id = ".$id.";";
			
			$this->save_picture_in_db($picture,$id,'update');
			
			if ($stmt = $db->prepare($stm)) {
				$stmt->bindParam(':message', $message);
				$stmt->execute();	
				return LANG_plugin_original_blog_success;		
			}
		}
	}
	
	private function save_picture($picture){

		$cleanname = $this->clean_name($picture["name"]); /*Entfernt Leerschläge, etc.*/
		
		$uploadfile = KONST_original_blog_image_path. basename($cleanname);

		$picture = $this->compress_picture($picture['tmp_name'], $uploadfile, 80);

	}
	
	private function compress_picture($source, $destination, $quality) {

		//Prüft, ob ein Bild übergeben wird
		if($source != ''){
			
			$info = getimagesize($source);

			if ($info['mime'] == 'image/jpeg') 
				$image = imagecreatefromjpeg($source);

			elseif ($info['mime'] == 'image/gif') 
				$image = imagecreatefromgif($source);

			elseif ($info['mime'] == 'image/png') 
				$image = imagecreatefrompng($source);

			imagejpeg($image, $destination, $quality);

			return $destination;
		}
	}
	
	private function save_picture_in_db($picture,$blogid,$mode){
		
		if(isset($picture) AND $picture != ''){
			
			$db = new PDO('sqlite:'.KONST_original_blog_db_path.'');
			
			if($mode == 'insert'){
				$db->exec("INSERT INTO pictures (`picture`,`visible`,`active`) VALUES ('".$picture."',1,1);");
				$pictureid = $db->lastInsertId();
				$db->exec("INSERT INTO blog_pictures (`fk_blog`,`fk_pictures`,`active`) VALUES (".$blogid.",".$pictureid.",1);");
			}
			
			if($mode == 'update'){

				$result = $db->query("SELECT fk_pictures FROM blog_pictures WHERE fk_blog = ".$blogid.";");

				$html = "";
				$id = "";
				if(is_null ($result) == false){ //Wenn das Array nicht NULL ist
					if($result){// Prüft, ob es das Objekt gibt
						while ($row = $result->fetch()){
							$id = $row['fk_pictures'];
						}
					}
				}
				
				//Falls eine ID gefunden wurde
				if($id != ''){
					$db->exec("UPDATE pictures SET picture = '".$picture."' WHERE id = ".$id.";");
				}else{
					$db->exec("INSERT INTO pictures (`picture`,`visible`,`active`) VALUES ('".$picture."',1,1);");
					$pictureid = $db->lastInsertId();
					$db->exec("INSERT INTO blog_pictures (`fk_blog`,`fk_pictures`,`active`) VALUES (".$blogid.",".$pictureid.",1);");
				}

			}
		}
			
	}
	
	private function clean_name($picture){
		
		$cleanname = strtolower($picture);
		$cleanname = str_replace(' ','',$cleanname);
		$cleanname = str_replace('&','',$cleanname);
		$cleanname = str_replace('?','',$cleanname);
		$cleanname = str_replace('ä','ae',$cleanname);
		$cleanname = str_replace('ö','oe',$cleanname);
		$cleanname = str_replace('ü','ue',$cleanname);
		$cleanname = str_replace('Ä','Ae',$cleanname);
		$cleanname = str_replace('Ö','Oe',$cleanname);
		$cleanname = str_replace('Ü','Ue',$cleanname);
		$cleanname = str_replace('(','_',$cleanname);
		$cleanname = str_replace(')','_',$cleanname);
		
		return $cleanname;
	}
	
	private function delete_entry($id) {
        
		$db = new PDO('sqlite:'.KONST_original_blog_db_path.'');
		$db->exec("UPDATE blog SET active=0 WHERE id = ".$id.";");
		$db->exec("UPDATE blog_pictures SET active=0 WHERE fk_blog = ".$id.";");
		return LANG_plugin_original_blog_deleted;
	}
	
	private function set_status($type,$id,$checked){
		
		$db = new PDO('sqlite:'.KONST_original_blog_db_path.'');
		if($checked == ''){
			$db->exec("UPDATE blog SET ".$type." = 0 WHERE id = ".$id.";");
		}else{
			$db->exec("UPDATE blog SET ".$type." = 1 WHERE id = ".$id.";");
		}

		return LANG_plugin_original_blog_success;
	}
	
	public function check_icon($pluginname){
		
		$html = '';
		if(file_exists('../'.$pluginname.'.php') AND (strpos($pluginname, 'Social-Media') !== false)){
			$html = '<td><a href="../Social-Media/feed.php?language='.LANG_current_language.'" target="_blank"><i aria-hidden="true" class="fa fa-share-square-o black"></i></a></td>';
		}
		
		if(file_exists('../'.$pluginname.'.php') AND (strpos($pluginname, '-News') !== false)){
			$html = '<td><i aria-hidden="true" class="fa fa-home black"></i></td>';
		}
		
		return $html;
		
	}

}
?>